Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 3770)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 3771)
@@ -52,5 +52,5 @@
    PRIVATE iom_p1d, iom_p2d, iom_p3d
 #if defined key_iomput
-   PRIVATE iom_set_domain_attr, iom_set_axis_attr, iom_set_field_attr, iom_set_file_attr
+   PRIVATE iom_set_domain_attr, iom_set_axis_attr, iom_set_field_attr, iom_set_file_attr, iom_set_grid_attr
    PRIVATE set_grid, set_scalar, set_xmlatt, set_mooring
 # endif
@@ -112,8 +112,8 @@
       ! horizontal grid definition
       CALL set_scalar
-      CALL set_grid( "grid_T", glamt, gphit ) 
-      CALL set_grid( "grid_U", glamu, gphiu )
-      CALL set_grid( "grid_V", glamv, gphiv )
-      CALL set_grid( "grid_W", glamt, gphit )
+      CALL set_grid( "T", glamt, gphit ) 
+      CALL set_grid( "U", glamu, gphiu )
+      CALL set_grid( "V", glamv, gphiv )
+      CALL set_grid( "W", glamt, gphit )
 
       ! vertical grid definition
@@ -1014,23 +1014,24 @@
 
    SUBROUTINE iom_set_domain_attr( cdname, ni_glo, nj_glo, ibegin, jbegin, ni, nj, zoom_ibegin, zoom_jbegin, zoom_ni, zoom_nj,   &
-      &                                    data_dim, data_ibegin, data_ni, data_jbegin, data_nj, lonvalue, latvalue )
-      CHARACTER(LEN=*)                , INTENT(in) ::   cdname
-      INTEGER               , OPTIONAL, INTENT(in) ::   ni_glo, nj_glo, ibegin, jbegin, ni, nj
-      INTEGER               , OPTIONAL, INTENT(in) ::   data_dim, data_ibegin, data_ni, data_jbegin, data_nj
-      INTEGER               , OPTIONAL, INTENT(in) ::   zoom_ibegin, zoom_jbegin, zoom_ni, zoom_nj
-      REAL(wp), DIMENSION(:), OPTIONAL, INTENT(in) ::   lonvalue, latvalue
-
-      IF ( xios_is_valid_domain(TRIM(cdname)) ) THEN
-         CALL xios_set_domain_attr( cdname, ni_glo=ni_glo, nj_glo=nj_glo, ibegin=ibegin, jbegin=jbegin, ni=ni, nj=nj  ,   &
-            &    data_dim=data_dim, data_ibegin=data_ibegin, data_ni=data_ni, data_jbegin=data_jbegin, data_nj=data_nj,   &
-            &    zoom_ibegin=zoom_ibegin, zoom_jbegin=zoom_jbegin, zoom_ni=zoom_ni, zoom_nj=zoom_nj,                      &
-            &    lonvalue=lonvalue, latvalue=latvalue )
-      ENDIF
-
-      IF ( xios_is_valid_domaingroup(TRIM(cdname)) ) THEN
+      &                                    data_dim, data_ibegin, data_ni, data_jbegin, data_nj, lonvalue, latvalue, mask )
+      CHARACTER(LEN=*)                 , INTENT(in) ::   cdname
+      INTEGER                , OPTIONAL, INTENT(in) ::   ni_glo, nj_glo, ibegin, jbegin, ni, nj
+      INTEGER                , OPTIONAL, INTENT(in) ::   data_dim, data_ibegin, data_ni, data_jbegin, data_nj
+      INTEGER                , OPTIONAL, INTENT(in) ::   zoom_ibegin, zoom_jbegin, zoom_ni, zoom_nj
+      REAL(wp), DIMENSION(:) , OPTIONAL, INTENT(in) ::   lonvalue, latvalue
+      LOGICAL, DIMENSION(:,:), OPTIONAL, INTENT(in) ::   mask
+
+      IF ( xios_is_valid_domain     (cdname) ) THEN
+         CALL xios_set_domain_attr     ( cdname, ni_glo=ni_glo, nj_glo=nj_glo, ibegin=ibegin, jbegin=jbegin, ni=ni, nj=nj,   &
+            &    data_dim=data_dim, data_ibegin=data_ibegin, data_ni=data_ni, data_jbegin=data_jbegin, data_nj=data_nj   ,   &
+            &    zoom_ibegin=zoom_ibegin, zoom_jbegin=zoom_jbegin, zoom_ni=zoom_ni, zoom_nj=zoom_nj,                         &
+            &    lonvalue=lonvalue, latvalue=latvalue,mask=mask )
+      ENDIF
+
+      IF ( xios_is_valid_domaingroup(cdname) ) THEN
          CALL xios_set_domaingroup_attr( cdname, ni_glo=ni_glo, nj_glo=nj_glo, ibegin=ibegin, jbegin=jbegin, ni=ni, nj=nj,   &
             &    data_dim=data_dim, data_ibegin=data_ibegin, data_ni=data_ni, data_jbegin=data_jbegin, data_nj=data_nj   ,   &
             &    zoom_ibegin=zoom_ibegin, zoom_jbegin=zoom_jbegin, zoom_ni=zoom_ni, zoom_nj=zoom_nj,                         &
-            &    lonvalue=lonvalue, latvalue=latvalue )
+            &    lonvalue=lonvalue, latvalue=latvalue,mask=mask )
       ENDIF
 
@@ -1041,12 +1042,6 @@
       CHARACTER(LEN=*)      , INTENT(in) ::   cdname
       REAL(wp), DIMENSION(:), INTENT(in) ::   paxis
-
-      IF ( xios_is_valid_axis(TRIM(cdname)) ) THEN
-         CALL xios_set_axis_attr( cdname, size=size(paxis),value=paxis )
-      ENDIF
-      IF ( xios_is_valid_axisgroup(TRIM(cdname)) ) THEN
-         CALL xios_set_axisgroup_attr( cdname, size=size(paxis),value=paxis )
-      ENDIF
-
+      IF ( xios_is_valid_axis     (cdname) )   CALL xios_set_axis_attr     ( cdname, size=size(paxis),value=paxis )
+      IF ( xios_is_valid_axisgroup(cdname) )   CALL xios_set_axisgroup_attr( cdname, size=size(paxis),value=paxis )
    END SUBROUTINE iom_set_axis_attr
 
@@ -1055,12 +1050,6 @@
       CHARACTER(LEN=*)          , INTENT(in) ::   cdname
       CHARACTER(LEN=*),OPTIONAL , INTENT(in) ::   freq_op
-
-      IF ( xios_is_valid_field(TRIM(cdname)) ) THEN
-         CALL xios_set_field_attr( cdname, freq_op=freq_op )
-      ENDIF
-      IF ( xios_is_valid_fieldgroup(TRIM(cdname)) ) THEN
-         CALL xios_set_fieldgroup_attr( cdname, freq_op=freq_op )
-      ENDIF
-
+      IF ( xios_is_valid_field     (cdname) )   CALL xios_set_field_attr     ( cdname, freq_op=freq_op )
+      IF ( xios_is_valid_fieldgroup(cdname) )   CALL xios_set_fieldgroup_attr( cdname, freq_op=freq_op )
    END SUBROUTINE iom_set_field_attr
 
@@ -1069,16 +1058,18 @@
       CHARACTER(LEN=*)          , INTENT(in) ::   cdname
       CHARACTER(LEN=*),OPTIONAL , INTENT(in) ::   name, name_suffix
-
-      IF ( xios_is_valid_file(TRIM(cdname)) ) THEN
-         CALL xios_set_file_attr( cdname, name=name, name_suffix=name_suffix )
-      ENDIF
-      IF ( xios_is_valid_filegroup(TRIM(cdname)) ) THEN
-         CALL xios_set_filegroup_attr( cdname, name=name, name_suffix=name_suffix )
-      ENDIF
-
+      IF ( xios_is_valid_file     (cdname) )   CALL xios_set_file_attr     ( cdname, name=name, name_suffix=name_suffix )
+      IF ( xios_is_valid_filegroup(cdname) )   CALL xios_set_filegroup_attr( cdname, name=name, name_suffix=name_suffix )
    END SUBROUTINE iom_set_file_attr
 
 
-   SUBROUTINE set_grid( cdname, plon, plat )
+   SUBROUTINE iom_set_grid_attr( cdname, mask )
+      CHARACTER(LEN=*)                   , INTENT(in) ::   cdname
+      LOGICAL, DIMENSION(:,:,:), OPTIONAL, INTENT(in) ::   mask
+      IF ( xios_is_valid_grid     (cdname) )   CALL xios_set_grid_attr     ( cdname, mask=mask )
+      IF ( xios_is_valid_gridgroup(cdname) )   CALL xios_set_gridgroup_attr( cdname, mask=mask )
+   END SUBROUTINE iom_set_grid_attr
+
+
+   SUBROUTINE set_grid( cdgrd, plon, plat )
       !!----------------------------------------------------------------------
       !!                     ***  ROUTINE   ***
@@ -1087,15 +1078,30 @@
       !!
       !!----------------------------------------------------------------------
-      CHARACTER(LEN=*)            , INTENT(in) ::   cdname
+      CHARACTER(LEN=1)            , INTENT(in) ::   cdgrd
       REAL(wp), DIMENSION(jpi,jpj), INTENT(in) ::   plon
       REAL(wp), DIMENSION(jpi,jpj), INTENT(in) ::   plat
+      !
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zmask
       INTEGER  :: ni,nj
       
       ni=nlei-nldi+1 ; nj=nlej-nldj+1
 
-      CALL iom_set_domain_attr(cdname, ni_glo=jpiglo, nj_glo=jpjglo, ibegin=nimpp+nldi-1, jbegin=njmpp+nldj-1, ni=ni, nj=nj)
-      CALL iom_set_domain_attr(cdname, data_dim=2, data_ibegin = 1-nldi, data_ni = jpi, data_jbegin = 1-nldj, data_nj = jpj)
-      CALL iom_set_domain_attr(cdname, lonvalue = RESHAPE(plon(nldi:nlei, nldj:nlej),(/ ni*nj /)),   &
-         &                             latvalue = RESHAPE(plat(nldi:nlei, nldj:nlej),(/ ni*nj /)))   
+      CALL iom_set_domain_attr("grid_"//cdgrd, ni_glo=jpiglo, nj_glo=jpjglo, ibegin=nimpp+nldi-1, jbegin=njmpp+nldj-1, ni=ni, nj=nj)
+      CALL iom_set_domain_attr("grid_"//cdgrd, data_dim=2, data_ibegin = 1-nldi, data_ni = jpi, data_jbegin = 1-nldj, data_nj = jpj)
+      CALL iom_set_domain_attr("grid_"//cdgrd, lonvalue = RESHAPE(plon(nldi:nlei, nldj:nlej),(/ ni*nj /)),   &
+         &                                     latvalue = RESHAPE(plat(nldi:nlei, nldj:nlej),(/ ni*nj /)))  
+
+      IF ( ln_mskland ) THEN
+         ! mask land points, keep values on coast line -> specific mask for U, V and W points
+         SELECT CASE ( cdgrd )
+         CASE('T')   ;   zmask(:,:,:)       = tmask(:,:,:)
+         CASE('U')   ;   zmask(2:jpim1,:,:) = tmask(2:jpim1,:,:) + tmask(3:jpi,:,:)   ;   CALL lbc_lnk( zmask, 'U', 1. )
+         CASE('V')   ;   zmask(:,2:jpjm1,:) = tmask(:,2:jpjm1,:) + tmask(:,3:jpi,:)   ;   CALL lbc_lnk( zmask, 'V', 1. )
+         CASE('W')   ;   zmask(:,:,2:jpk  ) = tmask(:,:,1:jpkm1) + tmask(:,:,2:jpk)   ;   zmask(:,:,1) = tmask(:,:,1)
+         END SELECT
+         !
+         CALL iom_set_domain_attr( "grid_"//cdgrd       , mask = zmask(:,:,1) /= 0. )
+         CALL iom_set_grid_attr  ( "grid_"//cdgrd//"_3D", mask = zmask(:,:,:) /= 0. )
+      ENDIF
       
    END SUBROUTINE set_grid
@@ -1159,29 +1165,23 @@
       clsuff(:) = (/ 'grid_T', 'grid_U', 'grid_V', 'grid_W', 'icemod', 'ptrc_T', 'diad_T', 'scalar' /)      
       DO jg = 1, SIZE(clsuff)                                                                  ! grid type
-         DO jh = 1, 12                                                                         ! 1, 2, 3, 4, 6, 12 hours
-            IF( MOD(12,jh) == 0 ) THEN 
-               WRITE(cl2,'(i2)') jh 
-               CALL dia_nam( clname, jh * ihhss, clsuff(jg), ldfsec = .TRUE. )
-               CALL iom_set_file_attr(TRIM(ADJUSTL(cl2))//'h_'//clsuff(jg), name=TRIM(clname))
-            ENDIF
+         DO jh = 1, 24                                                                         ! 1-24 hours
+            WRITE(cl2,'(i2)') jh 
+            CALL dia_nam( clname, jh * ihhss, clsuff(jg), ldfsec = .TRUE. )
+            CALL iom_set_file_attr(TRIM(ADJUSTL(cl2))//'h_'//clsuff(jg), name=TRIM(clname))
          END DO
-         DO jd = 1, 5, 2                                                                       ! 1, 3, 5 days
+         DO jd = 1, 30                                                                         ! 1-30 days
             WRITE(cl1,'(i1)') jd 
             CALL dia_nam( clname, jd * iddss, clsuff(jg), ldfsec = .TRUE. )
             CALL iom_set_file_attr(cl1//'d_'//clsuff(jg), name=TRIM(clname))
          END DO
-         DO jm = 1, 6                                                                          ! 1, 2, 3, 4, 6 months
-            IF( MOD(6,jm) == 0 ) THEN 
-               WRITE(cl1,'(i1)') jm 
-               CALL dia_nam( clname, -jm, clsuff(jg) )
-               CALL iom_set_file_attr(cl1//'m_'//clsuff(jg), name=TRIM(clname))
-            ENDIF
+         DO jm = 1, 11                                                                         ! 1-11 months
+            WRITE(cl1,'(i1)') jm 
+            CALL dia_nam( clname, -jm, clsuff(jg) )
+            CALL iom_set_file_attr(cl1//'m_'//clsuff(jg), name=TRIM(clname))
          END DO
-         DO jy = 1, 10                                                                         ! 1, 2, 5, 10 years  
-            IF( MOD(10,jy) == 0 ) THEN 
-               WRITE(cl2,'(i2)') jy 
-               CALL dia_nam( clname, -jy * iyymo, clsuff(jg) )
-               CALL iom_set_file_attr(TRIM(ADJUSTL(cl2))//'y_'//clsuff(jg), name=TRIM(clname))
-            ENDIF
+         DO jy = 1, 50                                                                         ! 1-50 years  
+            WRITE(cl2,'(i2)') jy 
+            CALL dia_nam( clname, -jy * iyymo, clsuff(jg) )
+            CALL iom_set_file_attr(TRIM(ADJUSTL(cl2))//'y_'//clsuff(jg), name=TRIM(clname))
          END DO
       END DO
